<template>
  <div class="account-modal fixed inset-0 touch-none" @wheel.prevent.stop @click="closeModal">
    <div class="flex h-full flex items-center justify-center">
      <div
        id="accountModal"
        class="animated-modal bg-bgdsec account-modal__content p-8 pt-16 xs:px-4 xs:pt-12 rounded-32 xs:rounded-b-none xs:rounded-t-32 flex flex-col items-center relative xs:fixed bottom-0 left-0 xs:w-full"
        :class="{ 'account-modal__content_raised': isEditEnable }"
        @click.stop
      >
        <UiButton
          color-type="outline"
          button-height="sm"
          class="w-12 rounded-16 absolute top-8 right-8"
          @click="logOut"
        >
          <img width="24" height="24" src="@/assets/images/ui/ui-logout.svg" />
        </UiButton>
        <div class="w-12 h-12 flex items-center justify-center shadow-secdhov rounded-16">
          <img width="40" height="40" src="@/assets/images/logotype.gif" class="rounded-12" />
        </div>
        <div class="relative mt-4">
          <input
            ref="nameInput"
            style="max-width: 250px; min-width: 0"
            :value="nameValue"
            :disabled="loading"
            class="account-modal__name-input text-2xl text-txtdprim leading-7 h-7 font-bold bg-transparent outline-none text-center"
            @focus="startEditing"
            @input="handleInput"
            @blur="stopEditing"
          />
          <img
            style="max-width: unset"
            width="24"
            height="24"
            src="@/assets/images/ui/ui-edit.svg"
            class="absolute -right-9 top-0.5 cursor-pointer"
            @click="startEditing"
          />
        </div>
        <p class="mt-2 font-medium leading-5 text-txtdsec">{{ keyAlias }}</p>
        <UiButton color-type="secondary" button-height="md" class="mt-12 rounded-24 w-full" @click="closeModal">
          <span v-if="!loading">{{ $t('account.close') }}</span>
          <LoadingSpinner color-type="white" v-else />
        </UiButton>
      </div>
    </div>
  </div>
</template>

<script>
import { updateUserInfo } from '@/api';
import UiButton from '@/components/ui/UiButton';
import LoadingSpinner from '@/components/ui/LoadingSpinner';

export default {
  name: 'AccountModal',

  components: { UiButton, LoadingSpinner },

  data() {
    return {
      nameValue: '',
      prevName: '',
      isEditEnable: false,
    };
  },

  computed: {
    userInfo() {
      return this.$store.state.auth.userInfo;
    },

    loading() {
      return this.$store.state.auth.userLoading;
    },

    keyAlias() {
      return this.$store.getters.keyAlias;
    },
  },

  watch: {
    userInfo() {
      this.nameValue = this.userInfo ? this.userInfo.full_name : '';
    },

    nameValue(newVal) {
      this.$refs.nameInput.style.width = (newVal ? newVal.length : 0) + 1 + 'ch';
    },
  },

  mounted() {
    this.nameValue = this.userInfo ? this.userInfo.full_name : '';
    this.$refs.nameInput.style.width = (this.nameValue ? this.nameValue.length : 0) + 1 + 'ch';
  },

  methods: {
    closeModal() {
      if (this.loading) return;
      this.$store.commit('setAccountModalDisplay', false);
    },

    startEditing() {
      if (this.loading) return;
      this.prevName = this.nameValue;
      this.isEditEnable = true;
      this.$refs.nameInput.focus();
    },

    handleInput(event) {
      this.nameValue = '';
      this.nameValue = event.target.value.slice(0, 15);
    },

    stopEditing() {
      this.isEditEnable = false;
      if (this.nameValue && this.nameValue !== this.prevName) {
        this.updateUserInfo();
      } else {
        this.nameValue = this.prevName;
      }
      document.activeElement.blur();
    },

    handleInputBlur() {
      console.log('blur');
    },

    logOut() {
      if (this.loading) return;
      this.$store.commit('setAccountModalDisplay', false);
      setTimeout(() => {
        this.$store.dispatch('logOut');
      }, 100);
    },

    async updateUserInfo() {
      this.$store.commit('setUserLoading', true);
      try {
        await updateUserInfo({ full_name: this.nameValue });
        this.$store.dispatch('getUserInfo');
      } catch (err) {
        console.error(err);
        this.$store.commit('setUserLoading', false);
      }
    },
  },
};
</script>

<style lang="scss">
.account-modal {
  background: rgba(12, 21, 33, 0.64);

  &__content {
    width: 500px;
    transition: height 190ms linear;

    @media (max-width: 600px) {
      height: 312px;
    }

    &_raised {
      @media (max-width: 600px) {
        height: 520px;
      }
    }
  }

  &__name-input {
    caret-color: #0066ff;
  }
}

@keyframes flashing {
  0% {
    opacity: 0%;
  }

  50% {
    opacity: 100%;
  }

  100% {
    opacity: 0%;
  }
}
</style>
